# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ItemArgs', 'Item']

@pulumi.input_type
class ItemArgs:
    def __init__(__self__, *,
                 vault: pulumi.Input[str],
                 category: Optional[pulumi.Input[str]] = None,
                 database: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 note_value: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 password_recipe: Optional[pulumi.Input['ItemPasswordRecipeArgs']] = None,
                 port: Optional[pulumi.Input[str]] = None,
                 sections: Optional[pulumi.Input[Sequence[pulumi.Input['ItemSectionArgs']]]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 title: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Item resource.
        :param pulumi.Input[str] vault: The UUID of the vault the item is in.
        :param pulumi.Input[str] category: The category of the item. One of ["login" "password" "database" "secure_note"]
        :param pulumi.Input[str] database: (Only applies to the database category) The name of the database.
        :param pulumi.Input[str] hostname: (Only applies to the database category) The address where the database can be found
        :param pulumi.Input[str] note_value: Secure Note value.
        :param pulumi.Input[str] password: Password for this item.
        :param pulumi.Input['ItemPasswordRecipeArgs'] password_recipe: The recipe used to generate a new value for a password.
        :param pulumi.Input[str] port: (Only applies to the database category) The port the database is listening on.
        :param pulumi.Input[Sequence[pulumi.Input['ItemSectionArgs']]] sections: A list of custom sections in an item
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: An array of strings of the tags assigned to the item.
        :param pulumi.Input[str] title: The title of the item.
        :param pulumi.Input[str] type: (Only applies to the database category) The type of database. One of ["db2" "filemaker" "msaccess" "mssql" "mysql" "oracle" "postgresql" "sqlite" "other"]
        :param pulumi.Input[str] url: The primary URL for the item.
        :param pulumi.Input[str] username: Username for this item.
        """
        pulumi.set(__self__, "vault", vault)
        if category is not None:
            pulumi.set(__self__, "category", category)
        if database is not None:
            pulumi.set(__self__, "database", database)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if note_value is not None:
            pulumi.set(__self__, "note_value", note_value)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if password_recipe is not None:
            pulumi.set(__self__, "password_recipe", password_recipe)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if sections is not None:
            pulumi.set(__self__, "sections", sections)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if title is not None:
            pulumi.set(__self__, "title", title)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if url is not None:
            pulumi.set(__self__, "url", url)
        if username is not None:
            pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter
    def vault(self) -> pulumi.Input[str]:
        """
        The UUID of the vault the item is in.
        """
        return pulumi.get(self, "vault")

    @vault.setter
    def vault(self, value: pulumi.Input[str]):
        pulumi.set(self, "vault", value)

    @property
    @pulumi.getter
    def category(self) -> Optional[pulumi.Input[str]]:
        """
        The category of the item. One of ["login" "password" "database" "secure_note"]
        """
        return pulumi.get(self, "category")

    @category.setter
    def category(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "category", value)

    @property
    @pulumi.getter
    def database(self) -> Optional[pulumi.Input[str]]:
        """
        (Only applies to the database category) The name of the database.
        """
        return pulumi.get(self, "database")

    @database.setter
    def database(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "database", value)

    @property
    @pulumi.getter
    def hostname(self) -> Optional[pulumi.Input[str]]:
        """
        (Only applies to the database category) The address where the database can be found
        """
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hostname", value)

    @property
    @pulumi.getter(name="noteValue")
    def note_value(self) -> Optional[pulumi.Input[str]]:
        """
        Secure Note value.
        """
        return pulumi.get(self, "note_value")

    @note_value.setter
    def note_value(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "note_value", value)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[str]]:
        """
        Password for this item.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter(name="passwordRecipe")
    def password_recipe(self) -> Optional[pulumi.Input['ItemPasswordRecipeArgs']]:
        """
        The recipe used to generate a new value for a password.
        """
        return pulumi.get(self, "password_recipe")

    @password_recipe.setter
    def password_recipe(self, value: Optional[pulumi.Input['ItemPasswordRecipeArgs']]):
        pulumi.set(self, "password_recipe", value)

    @property
    @pulumi.getter
    def port(self) -> Optional[pulumi.Input[str]]:
        """
        (Only applies to the database category) The port the database is listening on.
        """
        return pulumi.get(self, "port")

    @port.setter
    def port(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "port", value)

    @property
    @pulumi.getter
    def sections(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ItemSectionArgs']]]]:
        """
        A list of custom sections in an item
        """
        return pulumi.get(self, "sections")

    @sections.setter
    def sections(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ItemSectionArgs']]]]):
        pulumi.set(self, "sections", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        An array of strings of the tags assigned to the item.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def title(self) -> Optional[pulumi.Input[str]]:
        """
        The title of the item.
        """
        return pulumi.get(self, "title")

    @title.setter
    def title(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "title", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        (Only applies to the database category) The type of database. One of ["db2" "filemaker" "msaccess" "mssql" "mysql" "oracle" "postgresql" "sqlite" "other"]
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def url(self) -> Optional[pulumi.Input[str]]:
        """
        The primary URL for the item.
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "url", value)

    @property
    @pulumi.getter
    def username(self) -> Optional[pulumi.Input[str]]:
        """
        Username for this item.
        """
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "username", value)


@pulumi.input_type
class _ItemState:
    def __init__(__self__, *,
                 category: Optional[pulumi.Input[str]] = None,
                 database: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 note_value: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 password_recipe: Optional[pulumi.Input['ItemPasswordRecipeArgs']] = None,
                 port: Optional[pulumi.Input[str]] = None,
                 sections: Optional[pulumi.Input[Sequence[pulumi.Input['ItemSectionArgs']]]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 title: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 uuid: Optional[pulumi.Input[str]] = None,
                 vault: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Item resources.
        :param pulumi.Input[str] category: The category of the item. One of ["login" "password" "database" "secure_note"]
        :param pulumi.Input[str] database: (Only applies to the database category) The name of the database.
        :param pulumi.Input[str] hostname: (Only applies to the database category) The address where the database can be found
        :param pulumi.Input[str] note_value: Secure Note value.
        :param pulumi.Input[str] password: Password for this item.
        :param pulumi.Input['ItemPasswordRecipeArgs'] password_recipe: The recipe used to generate a new value for a password.
        :param pulumi.Input[str] port: (Only applies to the database category) The port the database is listening on.
        :param pulumi.Input[Sequence[pulumi.Input['ItemSectionArgs']]] sections: A list of custom sections in an item
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: An array of strings of the tags assigned to the item.
        :param pulumi.Input[str] title: The title of the item.
        :param pulumi.Input[str] type: (Only applies to the database category) The type of database. One of ["db2" "filemaker" "msaccess" "mssql" "mysql" "oracle" "postgresql" "sqlite" "other"]
        :param pulumi.Input[str] url: The primary URL for the item.
        :param pulumi.Input[str] username: Username for this item.
        :param pulumi.Input[str] uuid: The UUID of the item. Item identifiers are unique within a specific vault.
        :param pulumi.Input[str] vault: The UUID of the vault the item is in.
        """
        if category is not None:
            pulumi.set(__self__, "category", category)
        if database is not None:
            pulumi.set(__self__, "database", database)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if note_value is not None:
            pulumi.set(__self__, "note_value", note_value)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if password_recipe is not None:
            pulumi.set(__self__, "password_recipe", password_recipe)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if sections is not None:
            pulumi.set(__self__, "sections", sections)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if title is not None:
            pulumi.set(__self__, "title", title)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if url is not None:
            pulumi.set(__self__, "url", url)
        if username is not None:
            pulumi.set(__self__, "username", username)
        if uuid is not None:
            pulumi.set(__self__, "uuid", uuid)
        if vault is not None:
            pulumi.set(__self__, "vault", vault)

    @property
    @pulumi.getter
    def category(self) -> Optional[pulumi.Input[str]]:
        """
        The category of the item. One of ["login" "password" "database" "secure_note"]
        """
        return pulumi.get(self, "category")

    @category.setter
    def category(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "category", value)

    @property
    @pulumi.getter
    def database(self) -> Optional[pulumi.Input[str]]:
        """
        (Only applies to the database category) The name of the database.
        """
        return pulumi.get(self, "database")

    @database.setter
    def database(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "database", value)

    @property
    @pulumi.getter
    def hostname(self) -> Optional[pulumi.Input[str]]:
        """
        (Only applies to the database category) The address where the database can be found
        """
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hostname", value)

    @property
    @pulumi.getter(name="noteValue")
    def note_value(self) -> Optional[pulumi.Input[str]]:
        """
        Secure Note value.
        """
        return pulumi.get(self, "note_value")

    @note_value.setter
    def note_value(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "note_value", value)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[str]]:
        """
        Password for this item.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter(name="passwordRecipe")
    def password_recipe(self) -> Optional[pulumi.Input['ItemPasswordRecipeArgs']]:
        """
        The recipe used to generate a new value for a password.
        """
        return pulumi.get(self, "password_recipe")

    @password_recipe.setter
    def password_recipe(self, value: Optional[pulumi.Input['ItemPasswordRecipeArgs']]):
        pulumi.set(self, "password_recipe", value)

    @property
    @pulumi.getter
    def port(self) -> Optional[pulumi.Input[str]]:
        """
        (Only applies to the database category) The port the database is listening on.
        """
        return pulumi.get(self, "port")

    @port.setter
    def port(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "port", value)

    @property
    @pulumi.getter
    def sections(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ItemSectionArgs']]]]:
        """
        A list of custom sections in an item
        """
        return pulumi.get(self, "sections")

    @sections.setter
    def sections(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ItemSectionArgs']]]]):
        pulumi.set(self, "sections", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        An array of strings of the tags assigned to the item.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def title(self) -> Optional[pulumi.Input[str]]:
        """
        The title of the item.
        """
        return pulumi.get(self, "title")

    @title.setter
    def title(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "title", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        (Only applies to the database category) The type of database. One of ["db2" "filemaker" "msaccess" "mssql" "mysql" "oracle" "postgresql" "sqlite" "other"]
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def url(self) -> Optional[pulumi.Input[str]]:
        """
        The primary URL for the item.
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "url", value)

    @property
    @pulumi.getter
    def username(self) -> Optional[pulumi.Input[str]]:
        """
        Username for this item.
        """
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "username", value)

    @property
    @pulumi.getter
    def uuid(self) -> Optional[pulumi.Input[str]]:
        """
        The UUID of the item. Item identifiers are unique within a specific vault.
        """
        return pulumi.get(self, "uuid")

    @uuid.setter
    def uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "uuid", value)

    @property
    @pulumi.getter
    def vault(self) -> Optional[pulumi.Input[str]]:
        """
        The UUID of the vault the item is in.
        """
        return pulumi.get(self, "vault")

    @vault.setter
    def vault(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vault", value)


class Item(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 category: Optional[pulumi.Input[str]] = None,
                 database: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 note_value: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 password_recipe: Optional[pulumi.Input[Union['ItemPasswordRecipeArgs', 'ItemPasswordRecipeArgsDict']]] = None,
                 port: Optional[pulumi.Input[str]] = None,
                 sections: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ItemSectionArgs', 'ItemSectionArgsDict']]]]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 title: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 vault: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        A 1Password Item.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_onepassword as onepassword

        example = onepassword.Item("example",
            category="login",
            password_recipe={
                "length": 40,
                "symbols": False,
            },
            sections=[{
                "fields": [{
                    "label": "Example field",
                    "type": "DATE",
                    "value": "2024-01-31",
                }],
                "label": "Example section",
            }],
            title="Example Item Title",
            vault="your-vault-id")
        ```

        ## Import

        import an existing 1Password item

        ```sh
        $ pulumi import onepassword:index/item:Item myitem vaults/<vault uuid>/items/<item uuid>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] category: The category of the item. One of ["login" "password" "database" "secure_note"]
        :param pulumi.Input[str] database: (Only applies to the database category) The name of the database.
        :param pulumi.Input[str] hostname: (Only applies to the database category) The address where the database can be found
        :param pulumi.Input[str] note_value: Secure Note value.
        :param pulumi.Input[str] password: Password for this item.
        :param pulumi.Input[Union['ItemPasswordRecipeArgs', 'ItemPasswordRecipeArgsDict']] password_recipe: The recipe used to generate a new value for a password.
        :param pulumi.Input[str] port: (Only applies to the database category) The port the database is listening on.
        :param pulumi.Input[Sequence[pulumi.Input[Union['ItemSectionArgs', 'ItemSectionArgsDict']]]] sections: A list of custom sections in an item
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: An array of strings of the tags assigned to the item.
        :param pulumi.Input[str] title: The title of the item.
        :param pulumi.Input[str] type: (Only applies to the database category) The type of database. One of ["db2" "filemaker" "msaccess" "mssql" "mysql" "oracle" "postgresql" "sqlite" "other"]
        :param pulumi.Input[str] url: The primary URL for the item.
        :param pulumi.Input[str] username: Username for this item.
        :param pulumi.Input[str] vault: The UUID of the vault the item is in.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ItemArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        A 1Password Item.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_onepassword as onepassword

        example = onepassword.Item("example",
            category="login",
            password_recipe={
                "length": 40,
                "symbols": False,
            },
            sections=[{
                "fields": [{
                    "label": "Example field",
                    "type": "DATE",
                    "value": "2024-01-31",
                }],
                "label": "Example section",
            }],
            title="Example Item Title",
            vault="your-vault-id")
        ```

        ## Import

        import an existing 1Password item

        ```sh
        $ pulumi import onepassword:index/item:Item myitem vaults/<vault uuid>/items/<item uuid>
        ```

        :param str resource_name: The name of the resource.
        :param ItemArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ItemArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 category: Optional[pulumi.Input[str]] = None,
                 database: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 note_value: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 password_recipe: Optional[pulumi.Input[Union['ItemPasswordRecipeArgs', 'ItemPasswordRecipeArgsDict']]] = None,
                 port: Optional[pulumi.Input[str]] = None,
                 sections: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ItemSectionArgs', 'ItemSectionArgsDict']]]]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 title: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 vault: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ItemArgs.__new__(ItemArgs)

            __props__.__dict__["category"] = category
            __props__.__dict__["database"] = database
            __props__.__dict__["hostname"] = hostname
            __props__.__dict__["note_value"] = None if note_value is None else pulumi.Output.secret(note_value)
            __props__.__dict__["password"] = None if password is None else pulumi.Output.secret(password)
            __props__.__dict__["password_recipe"] = password_recipe
            __props__.__dict__["port"] = port
            __props__.__dict__["sections"] = sections
            __props__.__dict__["tags"] = tags
            __props__.__dict__["title"] = title
            __props__.__dict__["type"] = type
            __props__.__dict__["url"] = url
            __props__.__dict__["username"] = username
            if vault is None and not opts.urn:
                raise TypeError("Missing required property 'vault'")
            __props__.__dict__["vault"] = vault
            __props__.__dict__["uuid"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["noteValue", "password"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(Item, __self__).__init__(
            'onepassword:index/item:Item',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            category: Optional[pulumi.Input[str]] = None,
            database: Optional[pulumi.Input[str]] = None,
            hostname: Optional[pulumi.Input[str]] = None,
            note_value: Optional[pulumi.Input[str]] = None,
            password: Optional[pulumi.Input[str]] = None,
            password_recipe: Optional[pulumi.Input[Union['ItemPasswordRecipeArgs', 'ItemPasswordRecipeArgsDict']]] = None,
            port: Optional[pulumi.Input[str]] = None,
            sections: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ItemSectionArgs', 'ItemSectionArgsDict']]]]] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            title: Optional[pulumi.Input[str]] = None,
            type: Optional[pulumi.Input[str]] = None,
            url: Optional[pulumi.Input[str]] = None,
            username: Optional[pulumi.Input[str]] = None,
            uuid: Optional[pulumi.Input[str]] = None,
            vault: Optional[pulumi.Input[str]] = None) -> 'Item':
        """
        Get an existing Item resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] category: The category of the item. One of ["login" "password" "database" "secure_note"]
        :param pulumi.Input[str] database: (Only applies to the database category) The name of the database.
        :param pulumi.Input[str] hostname: (Only applies to the database category) The address where the database can be found
        :param pulumi.Input[str] note_value: Secure Note value.
        :param pulumi.Input[str] password: Password for this item.
        :param pulumi.Input[Union['ItemPasswordRecipeArgs', 'ItemPasswordRecipeArgsDict']] password_recipe: The recipe used to generate a new value for a password.
        :param pulumi.Input[str] port: (Only applies to the database category) The port the database is listening on.
        :param pulumi.Input[Sequence[pulumi.Input[Union['ItemSectionArgs', 'ItemSectionArgsDict']]]] sections: A list of custom sections in an item
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: An array of strings of the tags assigned to the item.
        :param pulumi.Input[str] title: The title of the item.
        :param pulumi.Input[str] type: (Only applies to the database category) The type of database. One of ["db2" "filemaker" "msaccess" "mssql" "mysql" "oracle" "postgresql" "sqlite" "other"]
        :param pulumi.Input[str] url: The primary URL for the item.
        :param pulumi.Input[str] username: Username for this item.
        :param pulumi.Input[str] uuid: The UUID of the item. Item identifiers are unique within a specific vault.
        :param pulumi.Input[str] vault: The UUID of the vault the item is in.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ItemState.__new__(_ItemState)

        __props__.__dict__["category"] = category
        __props__.__dict__["database"] = database
        __props__.__dict__["hostname"] = hostname
        __props__.__dict__["note_value"] = note_value
        __props__.__dict__["password"] = password
        __props__.__dict__["password_recipe"] = password_recipe
        __props__.__dict__["port"] = port
        __props__.__dict__["sections"] = sections
        __props__.__dict__["tags"] = tags
        __props__.__dict__["title"] = title
        __props__.__dict__["type"] = type
        __props__.__dict__["url"] = url
        __props__.__dict__["username"] = username
        __props__.__dict__["uuid"] = uuid
        __props__.__dict__["vault"] = vault
        return Item(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def category(self) -> pulumi.Output[str]:
        """
        The category of the item. One of ["login" "password" "database" "secure_note"]
        """
        return pulumi.get(self, "category")

    @property
    @pulumi.getter
    def database(self) -> pulumi.Output[Optional[str]]:
        """
        (Only applies to the database category) The name of the database.
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def hostname(self) -> pulumi.Output[Optional[str]]:
        """
        (Only applies to the database category) The address where the database can be found
        """
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter(name="noteValue")
    def note_value(self) -> pulumi.Output[Optional[str]]:
        """
        Secure Note value.
        """
        return pulumi.get(self, "note_value")

    @property
    @pulumi.getter
    def password(self) -> pulumi.Output[str]:
        """
        Password for this item.
        """
        return pulumi.get(self, "password")

    @property
    @pulumi.getter(name="passwordRecipe")
    def password_recipe(self) -> pulumi.Output[Optional['outputs.ItemPasswordRecipe']]:
        """
        The recipe used to generate a new value for a password.
        """
        return pulumi.get(self, "password_recipe")

    @property
    @pulumi.getter
    def port(self) -> pulumi.Output[Optional[str]]:
        """
        (Only applies to the database category) The port the database is listening on.
        """
        return pulumi.get(self, "port")

    @property
    @pulumi.getter
    def sections(self) -> pulumi.Output[Optional[Sequence['outputs.ItemSection']]]:
        """
        A list of custom sections in an item
        """
        return pulumi.get(self, "sections")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        An array of strings of the tags assigned to the item.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def title(self) -> pulumi.Output[Optional[str]]:
        """
        The title of the item.
        """
        return pulumi.get(self, "title")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[Optional[str]]:
        """
        (Only applies to the database category) The type of database. One of ["db2" "filemaker" "msaccess" "mssql" "mysql" "oracle" "postgresql" "sqlite" "other"]
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def url(self) -> pulumi.Output[Optional[str]]:
        """
        The primary URL for the item.
        """
        return pulumi.get(self, "url")

    @property
    @pulumi.getter
    def username(self) -> pulumi.Output[Optional[str]]:
        """
        Username for this item.
        """
        return pulumi.get(self, "username")

    @property
    @pulumi.getter
    def uuid(self) -> pulumi.Output[str]:
        """
        The UUID of the item. Item identifiers are unique within a specific vault.
        """
        return pulumi.get(self, "uuid")

    @property
    @pulumi.getter
    def vault(self) -> pulumi.Output[str]:
        """
        The UUID of the vault the item is in.
        """
        return pulumi.get(self, "vault")

