# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['ProviderArgs', 'Provider']

@pulumi.input_type
class ProviderArgs:
    def __init__(__self__, *,
                 account: Optional[pulumi.Input[str]] = None,
                 op_cli_path: Optional[pulumi.Input[str]] = None,
                 service_account_token: Optional[pulumi.Input[str]] = None,
                 token: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Provider resource.
        :param pulumi.Input[str] account: A valid account's sign-in address or ID to use biometrics unlock. Can also be sourced from `OP_ACCOUNT` environment
               variable. Provider will use the 1Password CLI if set.
        :param pulumi.Input[str] op_cli_path: The path to the 1Password CLI binary. Can also be sourced from `OP_CLI_PATH` environment variable. Defaults to `op`.
        :param pulumi.Input[str] service_account_token: A valid 1Password service account token. Can also be sourced from `OP_SERVICE_ACCOUNT_TOKEN` environment variable.
               Provider will use the 1Password CLI if set.
        :param pulumi.Input[str] token: A valid token for your 1Password Connect server. Can also be sourced from `OP_CONNECT_TOKEN` environment variable.
               Provider will use 1Password Connect server if set.
        :param pulumi.Input[str] url: The HTTP(S) URL where your 1Password Connect server can be found. Can also be sourced `OP_CONNECT_HOST` environment
               variable. Provider will use 1Password Connect server if set.
        """
        if account is None:
            account = _utilities.get_env('OP_ACCOUNT')
        if account is not None:
            pulumi.set(__self__, "account", account)
        if op_cli_path is None:
            op_cli_path = _utilities.get_env('OP_CLI_PATH')
        if op_cli_path is not None:
            pulumi.set(__self__, "op_cli_path", op_cli_path)
        if service_account_token is None:
            service_account_token = _utilities.get_env('OP_SERVICE_ACCOUNT_TOKEN')
        if service_account_token is not None:
            pulumi.set(__self__, "service_account_token", service_account_token)
        if token is None:
            token = _utilities.get_env('OP_CONNECT_TOKEN')
        if token is not None:
            pulumi.set(__self__, "token", token)
        if url is None:
            url = _utilities.get_env('OP_CONNECT_HOST')
        if url is not None:
            pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter
    def account(self) -> Optional[pulumi.Input[str]]:
        """
        A valid account's sign-in address or ID to use biometrics unlock. Can also be sourced from `OP_ACCOUNT` environment
        variable. Provider will use the 1Password CLI if set.
        """
        return pulumi.get(self, "account")

    @account.setter
    def account(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "account", value)

    @property
    @pulumi.getter(name="opCliPath")
    def op_cli_path(self) -> Optional[pulumi.Input[str]]:
        """
        The path to the 1Password CLI binary. Can also be sourced from `OP_CLI_PATH` environment variable. Defaults to `op`.
        """
        return pulumi.get(self, "op_cli_path")

    @op_cli_path.setter
    def op_cli_path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "op_cli_path", value)

    @property
    @pulumi.getter(name="serviceAccountToken")
    def service_account_token(self) -> Optional[pulumi.Input[str]]:
        """
        A valid 1Password service account token. Can also be sourced from `OP_SERVICE_ACCOUNT_TOKEN` environment variable.
        Provider will use the 1Password CLI if set.
        """
        return pulumi.get(self, "service_account_token")

    @service_account_token.setter
    def service_account_token(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_account_token", value)

    @property
    @pulumi.getter
    def token(self) -> Optional[pulumi.Input[str]]:
        """
        A valid token for your 1Password Connect server. Can also be sourced from `OP_CONNECT_TOKEN` environment variable.
        Provider will use 1Password Connect server if set.
        """
        return pulumi.get(self, "token")

    @token.setter
    def token(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "token", value)

    @property
    @pulumi.getter
    def url(self) -> Optional[pulumi.Input[str]]:
        """
        The HTTP(S) URL where your 1Password Connect server can be found. Can also be sourced `OP_CONNECT_HOST` environment
        variable. Provider will use 1Password Connect server if set.
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "url", value)


class Provider(pulumi.ProviderResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account: Optional[pulumi.Input[str]] = None,
                 op_cli_path: Optional[pulumi.Input[str]] = None,
                 service_account_token: Optional[pulumi.Input[str]] = None,
                 token: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The provider type for the onepassword package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account: A valid account's sign-in address or ID to use biometrics unlock. Can also be sourced from `OP_ACCOUNT` environment
               variable. Provider will use the 1Password CLI if set.
        :param pulumi.Input[str] op_cli_path: The path to the 1Password CLI binary. Can also be sourced from `OP_CLI_PATH` environment variable. Defaults to `op`.
        :param pulumi.Input[str] service_account_token: A valid 1Password service account token. Can also be sourced from `OP_SERVICE_ACCOUNT_TOKEN` environment variable.
               Provider will use the 1Password CLI if set.
        :param pulumi.Input[str] token: A valid token for your 1Password Connect server. Can also be sourced from `OP_CONNECT_TOKEN` environment variable.
               Provider will use 1Password Connect server if set.
        :param pulumi.Input[str] url: The HTTP(S) URL where your 1Password Connect server can be found. Can also be sourced `OP_CONNECT_HOST` environment
               variable. Provider will use 1Password Connect server if set.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ProviderArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The provider type for the onepassword package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param ProviderArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProviderArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account: Optional[pulumi.Input[str]] = None,
                 op_cli_path: Optional[pulumi.Input[str]] = None,
                 service_account_token: Optional[pulumi.Input[str]] = None,
                 token: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProviderArgs.__new__(ProviderArgs)

            if account is None:
                account = _utilities.get_env('OP_ACCOUNT')
            __props__.__dict__["account"] = account
            if op_cli_path is None:
                op_cli_path = _utilities.get_env('OP_CLI_PATH')
            __props__.__dict__["op_cli_path"] = op_cli_path
            if service_account_token is None:
                service_account_token = _utilities.get_env('OP_SERVICE_ACCOUNT_TOKEN')
            __props__.__dict__["service_account_token"] = None if service_account_token is None else pulumi.Output.secret(service_account_token)
            if token is None:
                token = _utilities.get_env('OP_CONNECT_TOKEN')
            __props__.__dict__["token"] = None if token is None else pulumi.Output.secret(token)
            if url is None:
                url = _utilities.get_env('OP_CONNECT_HOST')
            __props__.__dict__["url"] = url
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["serviceAccountToken", "token"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(Provider, __self__).__init__(
            'onepassword',
            resource_name,
            __props__,
            opts)

    @property
    @pulumi.getter
    def account(self) -> pulumi.Output[Optional[str]]:
        """
        A valid account's sign-in address or ID to use biometrics unlock. Can also be sourced from `OP_ACCOUNT` environment
        variable. Provider will use the 1Password CLI if set.
        """
        return pulumi.get(self, "account")

    @property
    @pulumi.getter(name="opCliPath")
    def op_cli_path(self) -> pulumi.Output[Optional[str]]:
        """
        The path to the 1Password CLI binary. Can also be sourced from `OP_CLI_PATH` environment variable. Defaults to `op`.
        """
        return pulumi.get(self, "op_cli_path")

    @property
    @pulumi.getter(name="serviceAccountToken")
    def service_account_token(self) -> pulumi.Output[Optional[str]]:
        """
        A valid 1Password service account token. Can also be sourced from `OP_SERVICE_ACCOUNT_TOKEN` environment variable.
        Provider will use the 1Password CLI if set.
        """
        return pulumi.get(self, "service_account_token")

    @property
    @pulumi.getter
    def token(self) -> pulumi.Output[Optional[str]]:
        """
        A valid token for your 1Password Connect server. Can also be sourced from `OP_CONNECT_TOKEN` environment variable.
        Provider will use 1Password Connect server if set.
        """
        return pulumi.get(self, "token")

    @property
    @pulumi.getter
    def url(self) -> pulumi.Output[Optional[str]]:
        """
        The HTTP(S) URL where your 1Password Connect server can be found. Can also be sourced `OP_CONNECT_HOST` environment
        variable. Provider will use 1Password Connect server if set.
        """
        return pulumi.get(self, "url")

